"use strict";
// *** WARNING: this file was generated by pulumi-language-nodejs. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertManager = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Automates the management and issuance of TLS certificates from various issuing sources within Kubernetes
 */
class CertManager extends pulumi.ComponentResource {
    /**
     * Returns true if the given object is an instance of CertManager.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === CertManager.__pulumiType;
    }
    /**
     * Create a CertManager resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name, args, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (!opts.id) {
            resourceInputs["affinity"] = args ? args.affinity : undefined;
            resourceInputs["cainjector"] = args ? args.cainjector : undefined;
            resourceInputs["clusterResourceNamespace"] = args ? args.clusterResourceNamespace : undefined;
            resourceInputs["containerSecurityContext"] = args ? args.containerSecurityContext : undefined;
            resourceInputs["deploymentAnnotations"] = args ? args.deploymentAnnotations : undefined;
            resourceInputs["extraArgs"] = args ? args.extraArgs : undefined;
            resourceInputs["extraEnv"] = args ? args.extraEnv : undefined;
            resourceInputs["extraVolumeMounts"] = args ? args.extraVolumeMounts : undefined;
            resourceInputs["extraVolumes"] = args ? args.extraVolumes : undefined;
            resourceInputs["featureGates"] = args ? args.featureGates : undefined;
            resourceInputs["global"] = args ? args.global : undefined;
            resourceInputs["helmOptions"] = args ? args.helmOptions : undefined;
            resourceInputs["http_proxy"] = args ? args.http_proxy : undefined;
            resourceInputs["https_proxy"] = args ? args.https_proxy : undefined;
            resourceInputs["image"] = args ? args.image : undefined;
            resourceInputs["ingressShim"] = args ? args.ingressShim : undefined;
            resourceInputs["installCRDs"] = args ? args.installCRDs : undefined;
            resourceInputs["no_proxy"] = args ? args.no_proxy : undefined;
            resourceInputs["nodeSelector"] = args ? args.nodeSelector : undefined;
            resourceInputs["podAnnotations"] = args ? args.podAnnotations : undefined;
            resourceInputs["podDnsConfig"] = args ? args.podDnsConfig : undefined;
            resourceInputs["podDnsPolicy"] = args ? args.podDnsPolicy : undefined;
            resourceInputs["podLabels"] = args ? args.podLabels : undefined;
            resourceInputs["prometheus"] = args ? args.prometheus : undefined;
            resourceInputs["replicaCount"] = args ? args.replicaCount : undefined;
            resourceInputs["resources"] = args ? args.resources : undefined;
            resourceInputs["securityContext"] = args ? args.securityContext : undefined;
            resourceInputs["serviceAccount"] = args ? args.serviceAccount : undefined;
            resourceInputs["serviceAnnotations"] = args ? args.serviceAnnotations : undefined;
            resourceInputs["serviceLabels"] = args ? args.serviceLabels : undefined;
            resourceInputs["startupapicheck"] = args ? args.startupapicheck : undefined;
            resourceInputs["strategy"] = args ? args.strategy : undefined;
            resourceInputs["tolerations"] = args ? args.tolerations : undefined;
            resourceInputs["webhook"] = args ? args.webhook : undefined;
            resourceInputs["status"] = undefined /*out*/;
        }
        else {
            resourceInputs["status"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(CertManager.__pulumiType, name, resourceInputs, opts, true /*remote*/);
    }
}
exports.CertManager = CertManager;
/** @internal */
CertManager.__pulumiType = 'kubernetes-cert-manager:index:CertManager';
//# sourceMappingURL=certManager.js.map